# A simple data structure.  Portfolio of stocks consisting
# of a stock name, number of shares held, and a purchse price

portfolio = [
    {'name': 'AA', 'shares': 100, 'price': 32.2},
    {'name': 'IBM', 'shares': 50, 'price': 91.1},
    {'name': 'CAT', 'shares': 150, 'price': 83.44},
    {'name': 'MSFT', 'shares': 200, 'price': 51.23},
    {'name': 'GE', 'shares': 95, 'price': 40.37},
    {'name': 'MSFT', 'shares': 50, 'price': 65.1},
    {'name': 'IBM', 'shares': 100, 'price': 70.44}
    ]

# One-to-many mapping?  Stock name -> All matching entries

from collections import defaultdict, Counter

by_name = defaultdict(list)
for s in portfolio:
    by_name[s['name']].append(s)   # Add to a list for each stock name

# Count total shares for each stock name
total_shares = Counter()
for s in portfolio:
    total_shares[s['name']] += s['shares']
    
